unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, math;

type
  TForm2 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    lienzo : TCanvas;

  public
    { Public declarations }
  end;

  procedure arco(LL : Tcanvas; xc,yc,R,t1,t2, tipo : integer);

var
  Form2: TForm2;

implementation

{$R *.dfm}

(*
  Referencia bsica

  LL     lienzo donde se trazar
  xc,yc  centro de la circunferencia que contiene al arco y Pie
  t1,t2  ngulo inicial y ngulo final en grados, Eje X :: 0 // CCW
  tipo   0: solo traza el arco
         1: traza la rebanada de pastel (Pie)
*)

procedure arco(LL : Tcanvas; xc,yc,R,t1,t2, tipo : integer);
var
  x1,y1,x2,y2,x3,y3,x4,y4     : integer;
  th1,th2                     : single;
begin
  x1 := xc - R;
  y1 := yc - R;
  x2 := xc + R;
  y2 := yc + R;

  th1 := DegToRad(t1);
  th2 := DegToRad(t2);

  x3 := round(xc + R*cos(th1));
  y3 := round(yc - R*sin(th1));

  x4 := round(xc + R*cos(th2));
  y4 := round(yc - R*sin(th2));

  if tipo=0
    then LL.Arc(x1,y1,x2,y2,x3,y3,x4,y4)
    else LL.Pie(x1,y1,x2,y2,x3,y3,x4,y4);
end;


procedure TForm2.FormCreate(Sender: TObject);
begin
  lienzo := Image1.Canvas;
end;


procedure TForm2.Button1Click(Sender: TObject);
begin
  lienzo.Pen.Width   := 4;
  lienzo.Pen.Color   := clGreen;
  lienzo.Brush.Color := clBlue;
  arco(lienzo, 100,70, 60, 0, 90, 0);

  lienzo.Pen.Width   := 3;
  lienzo.Pen.Color   := clRed;
  arco(lienzo, 100,70, 50, 0, 90, 1);

  lienzo.Pen.Width   := 2;
  lienzo.Pen.Color   := clBlack;
  lienzo.Brush.Color := clGreen;
  arco(lienzo, 250,70, 60, 0, 30, 0);
  arco(lienzo, 250,70, 50, 0, 30, 1);

  // El pastel pegado
  lienzo.Brush.Color := clGreen;
  arco(lienzo, 100,155, 60,   0, 100, 1);
  lienzo.Brush.Color := clRed;
  arco(lienzo, 100,155, 60, 100, 160, 1);
  lienzo.Brush.Color := clBlue;
  arco(lienzo, 100,155, 60, 160, 250, 1);
  lienzo.Brush.Color := clGray;
  arco(lienzo, 100,155, 60, 250, 360, 1);

  // El pastel cortado
  lienzo.Brush.Color := clGreen;
  arco(lienzo, 260,150, 65,   0, 100, 1);
  lienzo.Brush.Color := clRed;
  arco(lienzo, 250,150, 65, 110, 160, 1);
  lienzo.Brush.Color := clBlue;
  arco(lienzo, 250,160, 65, 170, 250, 1);
  lienzo.Brush.Color := clGray;
  arco(lienzo, 260,160, 65, 260, 350, 1);

end;

end.
